--[[----------------------------------------------------------------------------

KrCoroutineSupport.lua


--------------------------------------------------------------------------------

ADOBE CONFIDENTIAL
------------------
Copyright 2011 Adobe Systems Incorporated
All Rights Reserved.

NOTICE: All information contained herein is, and remain the property of
Adobe Systems Incorporated and its suppliers, if any. The intellectual and
technical concepts contained herein are proprietary to Adobe Systems
Incorporated and its suppliers and may be covered by U.S. and Foreign
Patents, patents in process, and are protected by trade secret or copyright
law.  Dissemination of this information or reproduction of this material is
strictly forbidden unless prior written permission is obtained from
Adobe Systems Incorporated.

----------------------------------------------------------------------------]]--

local coresume0 = coroutine.resume
local corunning = coroutine.running
local maxn = table.maxn
local coCallers = setmetatable( {}, { __mode = "kv" } )

-- plug map of callers into registry for use by debugger
debug.getregistry().KrDebuggerCoroutineCallers = coCallers

--==============================================================================

-- copied from AgTableUtils
local function packSparseArray( ... )
	return { n = select( '#', ...); ... }
end

----------------------------------------------------------------------------

local function unpackSparseArray( t, i, n )
	i = i or 1
	n = n or t.n or maxn( t )
	return unpack( t, i, n )
end

--------------------------------------------------------------------------------

coroutine.resume = function( co, ... )
	
	coCallers[ co ] = corunning()
	local result = packSparseArray( coresume0( co, ... ) )
	coCallers[ co ] = nil
	return unpackSparseArray( result )
	
end
